"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Message = exports.NEW_MESSAGE = void 0;

var _mqttClient = _interopRequireDefault(require("mqtt-client"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NEW_MESSAGE = 'NEW_MESSAGE';
exports.NEW_MESSAGE = NEW_MESSAGE;

var Message = function Message() {
  _classCallCheck(this, Message);

  this.CreateTime, this.HisCreateTime, this.HisID, this.ID, this.InfoContent, this.InfoDist, this.InfoLevel, this.InfoType, this.IsRead, this.MessType, this.ToUsers, this.UserID, this.app_config, this.app_path, this.web_config, this.web_path, this.time;
};

exports.Message = Message;

var Notifier =
/*#__PURE__*/
function () {
  function Notifier(userInfo) {
    _classCallCheck(this, Notifier);

    // this.userInfo=userInfo;
    this.userInfo = {
      site: '192_168_19_105_site_c8de50fc',
      OID: 5
    };
    this.messageCache = {
      totalCount: 0,
      messages: []
    }; // 当前消息缓存

    this._subscribers = {}; //订阅器缓存

    this._siteConfig = {
      site_code: this.userInfo.site,
      TcpIP: '',
      TcpPort: 443,
      TimeOut: '',
      KeepAlive: '',
      IsSSL: true,
      mqtt_path: '/mqtt'
    };
    this._config = {
      mqtt_path: '/mqtt',
      nginxStart: 'false',
      mqtt_mess: {
        IsSSL: false
      }
    };
    this.MQTTCount = 0;
    this.MQTTClient = null;
    this.MQTTOptions = {};
    this.IsNeedReconnect = true;
  } // 对外接口


  _createClass(Notifier, [{
    key: "start",
    value: function start() {
      return regeneratorRuntime.async(function start$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              this.loadHisMessages({
                userID: this.userInfo.OID
              });
              this.connectMQTTServer();

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: "stop",
    value: function stop() {
      this.disconnectMQTTServer();
    }
  }, {
    key: "subscribe",
    value: function subscribe(type, handler) {
      if (!(type in this._subscribers)) {
        this._subscribers[type] = [];
      }

      this._subscribers[type].push(handler);
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe(type, handler) {
      if (!(type in this._subscribers)) {
        console.log('无效事件无法删除');
      }

      if (!handler) {
        delete this._subscribers[type];
      } else {
        var idx = this._subscribers[type].findIndex(function (ele) {
          return ele === handler;
        });

        if (idx === -1) {
          console.log('无效事件无法删除');
          return;
        }

        this._subscribers[type].splice(idx, 1);

        if (this._subscribers[type].length === 0) {
          delete this._subscribers[type];
        }
      }
    }
  }, {
    key: "publish",
    value: function publish(type, payload) {
      if (!(type in this._subscribers) || this._subscribers[type].length === 0) return;

      this._subscribers[type].forEach(function (handler) {
        try {
          handler(payload);
        } catch (e) {
          console.log('订阅器委托错误');
        }
      });
    } // mqtt

  }, {
    key: "connectMQTTServer",
    value: function connectMQTTServer() {
      var _this = this;

      return regeneratorRuntime.async(function connectMQTTServer$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              this._getMqttSiteCode().then(function () {
                var hostname = _this._siteConfig.TcpIP,
                    port = _this._siteConfig.TcpPort,
                    clientId = 'client-' + _this._createGuid(),
                    timeout = 50,
                    keepAlive = 60,
                    cleanSession = true,
                    ssl = _this._siteConfig.IsSSL,
                    userName = 'mao2080',
                    password = '123',
                    path = _this._siteConfig.mqtt_path;

                _this.MQTTCount = 0;
                _this.MQTTClient = new _mqttClient["default"].Client(hostname, port, path, clientId);
                _this.MQTTOptions = {
                  invocationContext: {
                    host: hostname,
                    port: port,
                    path: path,
                    clientId: clientId
                  },
                  timeout: timeout,
                  keepAliveInterval: keepAlive,
                  cleanSession: cleanSession,
                  useSSL: ssl,
                  userName: userName,
                  password: password,
                  onSuccess: _this.onMQTTConnect.bind(_this),
                  onFailure: function onFailure(e) {
                    console.log(e);
                  }
                };

                _this.MQTTClient.connect(_this.MQTTOptions);

                _this.MQTTClient.onConnectionLost = _this.onMQTTConnectionLost.bind(_this);
                _this.MQTTClient.onMessageArrived = _this.onMessageArrived.bind(_this);
              });

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: "disconnectMQTTServer",
    value: function disconnectMQTTServer() {
      if (this.MQTTClient) {
        this.IsNeedReconnect = false;
        this.MQTTClient.diisconnect();
        this.MQTTClient = null;
      }
    }
  }, {
    key: "onMQTTConnect",
    value: function onMQTTConnect() {
      var site = this._siteConfig.site_code; //信息化主题

      var EIMTopic = site + "/EIM/info";
      this.MQTTClient.subscribe(EIMTopic); //节水主题

      var saveWaTopic = site + "/saveWater/info";
      this.MQTTClient.subscribe(saveWaTopic); //系统主题

      var sysTopic = site + "/system/info";
      this.MQTTClient.subscribe(sysTopic); //工单主题

      var caseTopic = site + "/workerOrder/info";
      this.MQTTClient.subscribe(caseTopic); //报警主题

      var SCADATopic = site + "/scada/alarm";
      this.MQTTClient.subscribe(SCADATopic); //用户主题

      var UserTopic = site + "/Message/".concat(this.userInfo.OID);
      this.MQTTClient.subscribe(UserTopic);
    }
  }, {
    key: "onMQTTConnectionLost",
    value: function onMQTTConnectionLost(responseObject) {
      debugger;
      var me = this;

      if (this.IsNeedReconnect) {
        this.MQTTClient.connect(me.MQTTOptions);
        this.MQTTtester = setInterval(function () {
          if (me.MQTTClient.isConnected) {
            clearInterval(me.MQTTtester);
          } else {
            me.MQTTClient.connect(me.MQTTOptions);
          }
        }, 1000);
      }
    }
  }, {
    key: "onMessageArrived",
    value: function onMessageArrived(message) {
      var me = this;

      try {
        console.log('收到消息:' + message.payloadString);
        var temp = JSON.parse(message.payloadString);

        var infoType = this._typeInfo(temp);

        if (temp.tousers == '' || me.userInfo.OID == temp.tousers || temp.tousers.includes(me.userInfo.OID + ',') || temp.tousers.includes(',' + me.userInfo.OID)) {
          var messContent = temp.content;

          if (me._siteConfig.MessageLevel && me._siteConfig.MessageLevel == '2.0') {
            messContent = me._messageThrome(infoType, JSON.parse(temp.content));
          }

          var timeH = (new Date() - new Date(temp.createTime)) / 1000 / 60;
          var timeMss = Math.abs(timeH) > 1440 ? temp.createTime.split('.')[0] : Math.abs(timeH) > 60 ? (timeH / 60).toFixed(0) + '小时前' : Math.abs(timeH) > 1 ? timeH.toFixed(0) + '分钟前' : '刚刚';
          var messString = {
            ID: temp.infoId,
            Info: messContent,
            InfoLevel: temp.level,
            time: "".concat(timeMss),
            infoType: infoType,
            messageType: '',
            dateTime: temp.createTime,
            web_config: temp.web_config,
            web_path: temp.web_path,
            messType: temp.MessType
          };

          var _message = me._handleMqttToMessage(messString);

          this.messageCache.totalCount += 1;
          this.messageCache.messages.push(_message);
          me.publish(NEW_MESSAGE, this.messageCache);
        }
      } catch (e) {
        console.log('收到消息处理异常:' + e.message);
      }
    } // 工具类

  }, {
    key: "loadHisMessages",
    value: function loadHisMessages(_ref) {
      var _this2 = this;

      var userID, _ref$pageIndex, pageIndex, _ref$pageSize, pageSize, me;

      return regeneratorRuntime.async(function loadHisMessages$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              userID = _ref.userID, _ref$pageIndex = _ref.pageIndex, pageIndex = _ref$pageIndex === void 0 ? 1 : _ref$pageIndex, _ref$pageSize = _ref.pageSize, pageSize = _ref$pageSize === void 0 ? 10 : _ref$pageSize;
              me = this;
              return _context3.abrupt("return", Http.getInformationInfo({
                userID: userID,
                pageIndex: pageIndex,
                pageSize: pageSize,
                'request.preventCache': Date.now()
              }).then(function (res) {
                var _this2$messageCache$m;

                var result = {
                  totalCount: res.totalRcdNum,
                  messages: res.getMe.map(_this2._handleHisToMessage)
                };
                _this2.messageCache.totalCount += result.totalCount;

                (_this2$messageCache$m = _this2.messageCache.messages).push.apply(_this2$messageCache$m, _toConsumableArray(result.messages));

                me.publish(NEW_MESSAGE, _this2.messageCache);
                return Promise.resolve(result);
              }));

            case 3:
            case "end":
              return _context3.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: "_getMqttSiteCode",
    value: function _getMqttSiteCode() {
      var me;
      return regeneratorRuntime.async(function _getMqttSiteCode$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              me = this;
              return _context4.abrupt("return", Http.getMqttSiteCode({
                'request.preventCache': Date.now()
              }).then(function (res) {
                if (res.say.statusCode == '0000') {
                  if (res.getMe[0]) {
                    me._siteConfig.IsSSL = res.getMe[0].IsSSL ? res.getMe[0].IsSSL : false;
                    me._siteConfig.site_code = res.getMe[0].SiteCode || me._siteConfig.site_code;
                    me._siteConfig.TcpIP = res.getMe[0].TcpIP;
                    me._siteConfig.TcpPort = res.getMe[0].TcpPort ? parseInt(res.getMe[0].TcpPort) : 8083;
                    me._siteConfig.MessageLevel = res.getMe[0].MessageLevel ? res.getMe[0].MessageLevel : '1.0';
                  }

                  if (res.getMe[0].NginxStart) {
                    me._siteConfig.TcpIP = window.location.hostname;
                    me._siteConfig.TcpPort = parseInt(window.location.port);
                    me._siteConfig.mqtt_path = '/ws/';
                  } else {
                    me._siteConfig.TcpIP = 'emqttd.panda-water.cn';
                    me._siteConfig.TcpPort = 443;
                    me._siteConfig.IsSSL = true;
                  }
                } else {
                  console.log('获取mqtt服务器参数失败');
                }
              }));

            case 2:
            case "end":
              return _context4.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: "_createGuid",
    value: function _createGuid() {
      return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = Math.random() * 16 | 0,
            v = c == 'x' ? r : r & 0x3 | 0x8;
        return v.toString(16);
      }).toUpperCase();
    }
  }, {
    key: "_typeInfo",
    value: function _typeInfo(temp) {
      var infoType = 'scadaType';

      switch (temp.infoType) {
        case '工单流程':
          infoType = 'caseType';
          break;

        case '系统消息':
        case '系统通知':
          infoType = 'sysType';
          break;

        case '节水通知':
          infoType = 'saveWaType';
          break;

        case '信息化':
          infoType = 'EIMType';
          break;

        case '消息提醒':
          infoType = 'remindType';
          break;

        default:
          break;
      }

      return infoType;
    }
  }, {
    key: "_messageThrome",
    value: function _messageThrome(themeName, info) {
      var messInfo = '';

      switch (themeName) {
        case 'caseType':
        case '工单提醒':
          messInfo = "\u3010".concat(info.caseType, "\u3011").concat(info.flowName, "\\n").concat(info.nodeName, "\\n\u627F\u529E\u610F\u89C1\uFF1A").concat(info.content);
          break;

        case 'scadaType':
        case '通用报警':
          messInfo = "\u3010".concat(info.alarmType, "\u3011").concat(info.alarmDevice, "\\n").concat(info.alarmContent, "\\n").concat(info.alarmValue, " / ").concat(info.alarmThreshold, "\\n").concat(info.deviceCode);
          break;

        case 'sysType':
        case '系统通知':
          messInfo = "\u3010".concat(info.noticeType, "\u3011").concat(info.noticeTitle, "\\n").concat(info.noticeContent);
          break;
        // case "remindType": case "remindType":
        //     messInfo = ``;
        //     break;

        default:
          break;
      }

      return messInfo;
    }
  }, {
    key: "_handleHisToMessage",
    value: function _handleHisToMessage(hisMessage) {
      var message = new Message();
      message = _objectSpread({}, hisMessage, {}, {
        ToUsers: hisMessage.Tousers
      });
      delete message['Tousers'];
      return message;
    }
  }, {
    key: "_handleMqttToMessage",
    value: function _handleMqttToMessage(mqttMessage) {
      var message = new Message();
      message.ID = mqttMessage.ID;
      message.InfoContent = mqttMessage.Info;
      message.InfoLevel = mqttMessage.InfoLevel;
      message.time = mqttMessage.time;
      message.infoType = mqttMessage.infoType;
      message.CreateTime = mqttMessage.dateTime;
      message.web_config = mqttMessage.web_config;
      message.web_path = mqttMessage.web_path;
      message.MessType = mqttMessage.messType;
      return message;
    }
  }]);

  return Notifier;
}();

var _default = Notifier;
exports["default"] = _default;